/*
 * ________________________________________________________________________________________________________
 * Copyright (c) 2017 InvenSense Inc. All rights reserved.
 *
 * This software, related documentation and any modifications thereto (collectively “Software”) is subject
 * to InvenSense and its licensors' intellectual property rights under U.S. and international copyright
 * and other intellectual property rights laws.
 *
 * InvenSense and its licensors retain all intellectual property and proprietary rights in and to the Software
 * and any use, reproduction, disclosure or distribution of the Software without an express license agreement
 * from InvenSense is strictly prohibited.
 *
 * EXCEPT AS OTHERWISE PROVIDED IN A LICENSE AGREEMENT BETWEEN THE PARTIES, THE SOFTWARE IS
 * PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT.
 * EXCEPT AS OTHERWISE PROVIDED IN A LICENSE AGREEMENT BETWEEN THE PARTIES, IN NO EVENT SHALL
 * INVENSENSE BE LIABLE FOR ANY DIRECT, SPECIAL, INDIRECT, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, OR ANY
 * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE
 * OF THE SOFTWARE.
 * ________________________________________________________________________________________________________
 */

#include "example_smd.h"

#include "Invn/EmbUtils/Message.h"
#include "Invn/EmbUtils/RingBuffer.h"

/* board driver */
#include "common.h"
#include "timer.h"

/* --------------------------------------------------------------------------------------
 *  Static and extern variables
 * -------------------------------------------------------------------------------------- */

/* IMU driver object */
static struct inv_imu_device icm_driver;

/* Buffer to keep track of the timestamp when IMU data ready interrupt fires. */
extern RINGBUFFER(timestamp_buffer, 64, uint64_t);

/* --------------------------------------------------------------------------------------
 *  Functions definition
 * -------------------------------------------------------------------------------------- */

int setup_imu_device(const struct inv_imu_serif *icm_serif)
{
	int     rc = 0;
	uint8_t who_am_i;

	/* Init device */
	rc = inv_imu_init(&icm_driver, icm_serif, NULL);
	if (rc != INV_ERROR_SUCCESS) {
		INV_MSG(INV_MSG_LEVEL_ERROR, "Failed to initialize IMU!");
		return rc;
	}

	/* Check WHOAMI */
	rc = inv_imu_get_who_am_i(&icm_driver, &who_am_i);
	if (rc != INV_ERROR_SUCCESS) {
		INV_MSG(INV_MSG_LEVEL_ERROR, "Failed to read whoami!");
		return rc;
	}

	if (who_am_i != ICM_WHOAMI) {
		INV_MSG(INV_MSG_LEVEL_ERROR, "Bad WHOAMI value!");
		INV_MSG(INV_MSG_LEVEL_ERROR, "Read 0x%02x, expected 0x%02x", who_am_i, ICM_WHOAMI);
		return INV_ERROR;
	}

	RINGBUFFER_CLEAR(&timestamp_buffer);

	return rc;
}

int configure_imu_device()
{
	int                           rc = 0;
	inv_imu_apex_parameters_t     apex_inputs;
	inv_imu_interrupt_parameter_t config_int = { (inv_imu_interrupt_value)0 };

	/* Disabling FIFO to avoid extra power consumption due to ALP config */
	rc |= inv_imu_configure_fifo(&icm_driver, INV_IMU_FIFO_DISABLED);

	/* Accel frequency should be at least or higher 
	 * than the Pedometer frequency to properly running the APEX feature 
	 */
	rc |= inv_imu_set_accel_frequency(&icm_driver, ACCEL_CONFIG0_ODR_50_HZ);
	rc |= inv_imu_apex_set_frequency(&icm_driver, APEX_CONFIG1_DMP_ODR_50Hz);

	/* Set 2x averaging, in order to minimize power consumption (16x by default) */
	rc |= inv_imu_set_accel_lp_avg(&icm_driver, ACCEL_CONFIG1_ACCEL_FILT_AVG_2);
	rc |= inv_imu_enable_accel_low_power_mode(&icm_driver);

	/* Get the default parameters for the APEX features */
	rc |= inv_imu_apex_init_parameters_struct(&icm_driver, &apex_inputs);

	/* Configure the programmable parameter for Low Power mode (WoM+Pedometer+SMD) or Normal mode */
	apex_inputs.power_save = SMD_POWER_SAVE_MODE;
	if (apex_inputs.power_save == APEX_CONFIG0_DMP_POWER_SAVE_EN) {
		/* Configure and enable WOM to wake-up the DMP once it goes in power save mode */
		rc |= inv_imu_configure_wom(&icm_driver, DEFAULT_WOM_THS, DEFAULT_WOM_THS, DEFAULT_WOM_THS,
		                            WOM_CONFIG_WOM_INT_MODE_ANDED, WOM_CONFIG_WOM_INT_DUR_1_SMPL);
		rc |= inv_imu_enable_wom(&icm_driver); /* Enable WOM and disable fifo threshold */
	}

	/* Initializes APEX features */
	rc |= inv_imu_apex_configure_parameters(&icm_driver, &apex_inputs);

	rc |= inv_imu_apex_enable_pedometer(&icm_driver);
	rc |= inv_imu_apex_enable_smd(&icm_driver);

	/* Disable fifo threshold, data ready, WOM and pedometer interrupts INT1 */
	inv_imu_get_config_int1(&icm_driver, &config_int);
	config_int.INV_FIFO_THS = INV_IMU_DISABLE;
	config_int.INV_UI_DRDY  = INV_IMU_DISABLE;
	config_int.INV_WOM_X    = INV_IMU_DISABLE;
	config_int.INV_WOM_Y    = INV_IMU_DISABLE;
	config_int.INV_WOM_Z    = INV_IMU_DISABLE;
	config_int.INV_STEP_DET = INV_IMU_DISABLE;
	inv_imu_set_config_int1(&icm_driver, &config_int);

	return rc;
}

int get_imu_data(void)
{
	uint8_t  int_status2;
	uint64_t irq_timestamp = 0;
	int      rc;

	/*
	 * Extract the timestamp that was buffered when current packet IRQ fired. See 
	 * ext_interrupt_cb() in main.c for more details.
	 * As timestamp buffer is filled in interrupt handler, we should pop it with
	 * interrupts disabled to avoid any concurrent access.
	 */
	inv_disable_irq();
	if (!RINGBUFFER_EMPTY(&timestamp_buffer))
		RINGBUFFER_POP(&timestamp_buffer, &irq_timestamp);
	inv_enable_irq();

	/*
	 *  Read SMD interrupt status
	 */
	rc = inv_imu_read_reg(&icm_driver, INT_STATUS2, 1, &int_status2);
	if (rc != INV_ERROR_SUCCESS)
		return rc;

	if (int_status2 & INT_STATUS2_SMD_INT_MASK) {
		INV_MSG(INV_MSG_LEVEL_INFO, "%u: SMD detected, disabling it", (uint32_t)irq_timestamp);
		return inv_imu_apex_disable_smd(&icm_driver);
	}

	return rc;
}
